package biggests.gui;

import java.awt.*;
import java.util.*;

import javax.swing.*;

/**
 * <p>Title: BiGGEsTS - Biclustering Gene Expression Time Series</p>
 *
 * <p>Description: BiGGEsTS - Application</p>
 *
 * <p>Copyright:   Copyright (C) 2007  Joana Gonalves
 *                 This program is free software; you can redistribute
 *                 it and/or modify it under the terms of the GNU General
 *                 Public License as published by the Free Software
 *                 Foundation; either version 3 of the License, or
 *                 any later version.
 *
 *                 This program is distributed in the hope that it will
 *                 be useful, but WITHOUT ANY WARRANTY; without even the
 *                 implied warranty of MERCHANTABILITY or FITNESS FOR A
 *                 PARTICULAR PURPOSE.  See the
 *                 <a href="http://www.gnu.org/licenses/gpl.html">
 *                 GNU General Public License</a> for more details.
 * </p>
 *
 * @author Joana Gonalves
 */
public class BiggestsApplication {
    private boolean packFrame = false;
    private BiggestsFrame frame;

    /**
     * Starts the application.
     */
    public BiggestsApplication() {
        Locale.setDefault(Locale.ENGLISH);
        frame = new BiggestsFrame();

        /**
         * validate frames that have preset sizes
         * pack frames that have useful preferred size info, e.g. from their layout
         */
        if (packFrame) {
            frame.pack();
        } else {
            frame.validate();
        }

        /**
         * center the window
         */
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = frame.getSize();
        if (frameSize.height > screenSize.height) {
            frameSize.height = screenSize.height;
        }
        if (frameSize.width > screenSize.width) {
            frameSize.width = screenSize.width;
        }
        frame.setLocation((screenSize.width - frameSize.width) / 2, 0);

        frame.setVisible(true);
    }

    /**
     * Application entry point.
     *
     * @param args String[]
     */
    public static void main(String[] args) {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                try {
                    UIManager.setLookAndFeel(UIManager.
                            getCrossPlatformLookAndFeelClassName());
                } catch (Exception exception) {
                    exception.printStackTrace();
                }

                new BiggestsApplication();
            }
        });
    }
}
