package biggests.gui;

import java.io.*;

import javax.swing.*;

import biggests.clustering.*;
import biggests.utils.*;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright:   Copyright (C) 2007  Joana Gonalves
 *                 This program is free software; you can redistribute
 *                 it and/or modify it under the terms of the GNU General
 *                 Public License as published by the Free Software
 *                 Foundation; either version 3 of the License, or
 *                 any later version.
 *
 *                 This program is distributed in the hope that it will
 *                 be useful, but WITHOUT ANY WARRANTY; without even the
 *                 implied warranty of MERCHANTABILITY or FITNESS FOR A
 *                 PARTICULAR PURPOSE.  See the
 *                 <a href="http://www.gnu.org/licenses/gpl.html">
 *                 GNU General Public License</a> for more details.
 * </p>
 *
 * @author Joana Gonalves
 */
public class ThreadHierarchicalClustering extends Thread {
    BiggestsFrame frame;
    private HierarchicalClustering hierarchicalClustering;
    private char genesMetric;
    private char conditionsMetric;
    private char clusteringMethod;
    private String outputFilesDirectoryPath;
    private String jobName;
    private ProgressBarFrame progressFrame;

    public ThreadHierarchicalClustering(BiggestsFrame frame,
                                        HierarchicalClustering
                                        hierarchicalClustering,
                                        char genesMetric,
                                        char conditionsMetric,
                                        char clusteringMethod,
                                        String outputFilesDirectoryPath,
                                        String jobName) {
        this.frame = frame;
        this.hierarchicalClustering = hierarchicalClustering;
        this.genesMetric = genesMetric;
        this.conditionsMetric = conditionsMetric;
        this.clusteringMethod = clusteringMethod;
        this.outputFilesDirectoryPath = outputFilesDirectoryPath;
        this.jobName = jobName;
        progressFrame =
                new ProgressBarFrame(frame, this,
                                     "preparing to apply hierarchical clustering...", true);
        this.start();
    }

    public void run() {
        try {
            progressFrame.setString("performing hierarchical clustering...");
            hierarchicalClustering.hierarchicalClusteringWithFileOutput(
                    genesMetric,
                    conditionsMetric,
                    clusteringMethod,
                    outputFilesDirectoryPath + File.separator + jobName);
        } catch (IOException ex) {
            ex.printStackTrace();
            progressFrame.dispose();
            JOptionPane.showMessageDialog(
                    frame, "Couldn't write dendrogram output files.",
                    "Couldn't write dendrogram", JOptionPane.ERROR_MESSAGE);
            return;
        }

        progressFrame.setString(
                "reading hierarchical clustering output files...");
        frame.getPanelAnalyzingMatrixDendrogram().showDendrogram(
                outputFilesDirectoryPath, jobName + ".cdt");
        progressFrame.dispose();
    }
}
